# -*- coding: utf-8 -*-
# Generated by Django 1.11.29 on 2021-04-08 11:24
from __future__ import unicode_literals

import datetime
from django.conf import settings
import django.contrib.gis.db.models.fields
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import django_countries.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('datamodel', '0001_initial'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('sessions', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='BBox',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('bbox_type', models.CharField(choices=[('global', 'Global'), ('oceanic', 'Oceânica'), ('atm', 'Atmosférica'), ('waves', 'Ondas')], max_length=10)),
                ('color', models.CharField(default='#333', help_text='Hex color', max_length=7)),
                ('notes', models.CharField(blank=True, max_length=100)),
                ('polygon', django.contrib.gis.db.models.fields.PolygonField(srid=4326)),
            ],
            options={
                'verbose_name': 'Detail Bounding Box',
                'verbose_name_plural': 'Bounding Boxes',
            },
        ),
        migrations.CreateModel(
            name='BoundaryKind',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=100)),
                ('reference', models.SlugField(blank=True)),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('category', models.CharField(choices=[('atm', 'Atmospheric'), ('wat', 'Water')], max_length=6)),
            ],
        ),
        migrations.CreateModel(
            name='CRS',
            fields=[
                ('code', models.IntegerField(auto_created=True, db_index=True, primary_key=True, serialize=False, unique=True)),
                ('name', models.CharField(max_length=100)),
                ('description', models.TextField(blank=True, max_length=250)),
                ('active', models.BooleanField(default=True)),
            ],
            options={
                'verbose_name': 'Detail CRS',
                'verbose_name_plural': 'CRSs',
            },
        ),
        migrations.CreateModel(
            name='CRSV',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('description', models.TextField(blank=True, max_length=250)),
                ('offset', models.FloatField(default=0.0)),
                ('code', models.IntegerField(blank=True, help_text='Código EPSG se aplicável', null=True, unique=True)),
                ('active', models.BooleanField(default=True)),
            ],
            options={
                'verbose_name': 'Detail CRS Vertical',
                'verbose_name_plural': 'CRSs Vertical',
            },
        ),
        migrations.CreateModel(
            name='Deployment',
            fields=[
                ('deployment_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='datamodel.Deployment')),
                ('step', models.IntegerField(blank=True, null=True)),
                ('step1', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('step2', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('step3', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('step4', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('step5', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('step6', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('step7', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('config_json', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('clone', models.IntegerField(blank=True, null=True)),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Detail Deployment',
                'verbose_name_plural': 'Deployments',
            },
            bases=('datamodel.deployment',),
        ),
        migrations.CreateModel(
            name='DeploymentBoundary',
            fields=[
                ('deploymentboundary_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='datamodel.DeploymentBoundary')),
                ('boundary_line', django.contrib.gis.db.models.fields.LineStringField(blank=True, null=True, srid=4326)),
                ('boundary_kind', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='front.BoundaryKind')),
            ],
            options={
                'abstract': False,
            },
            bases=('datamodel.deploymentboundary',),
        ),
        migrations.CreateModel(
            name='ExtendDeployRequest',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('creation_datetime', models.DateTimeField(default=datetime.datetime.now)),
                ('motive', models.TextField()),
                ('to_date', models.DateField()),
                ('closed', models.BooleanField(default=False)),
                ('accepted', models.BooleanField(default=False)),
                ('reply', models.TextField(blank=True)),
                ('reply_date', models.DateField(blank=True, null=True)),
                ('deployment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='front.Deployment')),
            ],
        ),
        migrations.CreateModel(
            name='ForcingSource',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('active', models.BooleanField(default=True)),
                ('forcing_kind', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='front.BoundaryKind')),
                ('parent', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ForcingSource')),
            ],
            options={
                'verbose_name': 'Forcing Source',
                'verbose_name_plural': 'Forcing Sources',
            },
        ),
        migrations.CreateModel(
            name='ModelParameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ui_notes', models.CharField(blank=True, max_length=120)),
                ('category', models.CharField(blank=True, max_length=250)),
                ('order_by', models.CharField(blank=True, help_text='Campo que ordena ascendentemente parâmetros', max_length=10)),
                ('par_type', models.IntegerField(choices=[(6, 'Array'), (0, 'Boolean'), (5, 'Choice'), (1, 'Float'), (2, 'Integer'), (4, 'List'), (3, 'Text')])),
                ('active', models.BooleanField(default=True, help_text='Campo ativo, é considerado na interface, mesmo que não esteja visível')),
                ('predefined', models.BooleanField(default=True, help_text='Campo visível nos parâmetros predefinidos, se estiver ativo')),
                ('readonly', models.BooleanField(default=True, help_text='Campo de leitura apenas')),
                ('ruleset', django.contrib.postgres.fields.jsonb.JSONField(blank=True, help_text='Preencher com JSON', null=True)),
                ('choices', models.TextField(blank=True, help_text="Preencher 'valor: Descrição' | Delimitador das Opções: quebra de linha | Exemplo: 1: Cartesian", max_length=1000)),
                ('min_value', models.FloatField(blank=True, null=True)),
                ('max_value', models.FloatField(blank=True, null=True)),
                ('parent', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelParameter')),
            ],
            options={
                'verbose_name': 'Detail Model Parameter',
                'verbose_name_plural': 'Model Parameters',
            },
        ),
        migrations.CreateModel(
            name='ModelVersion',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('public', models.BooleanField(default=True)),
                ('boundarykind', models.ManyToManyField(blank=True, to='front.BoundaryKind')),
                ('parent', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='child', to='datamodel.ModelVersion')),
            ],
            options={
                'verbose_name': 'Detail Model Version',
                'verbose_name_plural': 'Model Versions',
            },
        ),
        migrations.CreateModel(
            name='ModelVersionParameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ui_notes', models.CharField(blank=True, max_length=120)),
                ('category', models.CharField(blank=True, max_length=250)),
                ('order_by', models.CharField(blank=True, help_text='Campo que ordena ascendentemente parâmetros', max_length=10)),
                ('par_type', models.IntegerField(choices=[(6, 'Array'), (0, 'Boolean'), (5, 'Choice'), (1, 'Float'), (2, 'Integer'), (4, 'List'), (3, 'Text')])),
                ('active', models.BooleanField(default=True, help_text='Campo ativo, é considerado na interface, mesmo que não esteja visível')),
                ('predefined', models.BooleanField(default=True, help_text='Campo visível nos parâmetros predefinidos, se estiver ativo')),
                ('readonly', models.BooleanField(default=True, help_text='Campo de leitura apenas')),
                ('ruleset', django.contrib.postgres.fields.jsonb.JSONField(blank=True, help_text='Preencher com JSON', null=True)),
                ('choices', models.TextField(blank=True, help_text="Preencher 'valor: Descrição' | Delimitador das Opções: quebra de linha | Exemplo: 1: Cartesian", max_length=1000)),
                ('min_value', models.FloatField(blank=True, null=True)),
                ('max_value', models.FloatField(blank=True, null=True)),
                ('parent', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelVersionParameter')),
            ],
            options={
                'verbose_name': 'Detail ModelVersion Parameter',
                'verbose_name_plural': 'ModelVersion Parameters',
            },
        ),
        migrations.CreateModel(
            name='ModelVersionParameter3D',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ui_notes', models.CharField(blank=True, max_length=120)),
                ('category', models.CharField(blank=True, max_length=250)),
                ('order_by', models.CharField(blank=True, help_text='Campo que ordena ascendentemente parâmetros', max_length=10)),
                ('par_type', models.IntegerField(choices=[(6, 'Array'), (0, 'Boolean'), (5, 'Choice'), (1, 'Float'), (2, 'Integer'), (4, 'List'), (3, 'Text')])),
                ('active', models.BooleanField(default=True, help_text='Campo ativo, é considerado na interface, mesmo que não esteja visível')),
                ('predefined', models.BooleanField(default=True, help_text='Campo visível nos parâmetros predefinidos, se estiver ativo')),
                ('readonly', models.BooleanField(default=True, help_text='Campo de leitura apenas')),
                ('ruleset', django.contrib.postgres.fields.jsonb.JSONField(blank=True, help_text='Preencher com JSON', null=True)),
                ('choices', models.TextField(blank=True, help_text="Preencher 'valor: Descrição' | Delimitador das Opções: quebra de linha | Exemplo: 1: Cartesian", max_length=1000)),
                ('min_value', models.FloatField(blank=True, null=True)),
                ('max_value', models.FloatField(blank=True, null=True)),
                ('parent', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelVersionParameter')),
            ],
            options={
                'verbose_name': 'Detail ModelVersion Parameter 3D',
                'verbose_name_plural': 'ModelVersion Parameters 3D',
            },
        ),
        migrations.CreateModel(
            name='ModelVersionParameterWave',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ui_notes', models.CharField(blank=True, max_length=120)),
                ('category', models.CharField(blank=True, max_length=250)),
                ('order_by', models.CharField(blank=True, help_text='Campo que ordena ascendentemente parâmetros', max_length=10)),
                ('par_type', models.IntegerField(choices=[(6, 'Array'), (0, 'Boolean'), (5, 'Choice'), (1, 'Float'), (2, 'Integer'), (4, 'List'), (3, 'Text')])),
                ('active', models.BooleanField(default=True, help_text='Campo ativo, é considerado na interface, mesmo que não esteja visível')),
                ('predefined', models.BooleanField(default=True, help_text='Campo visível nos parâmetros predefinidos, se estiver ativo')),
                ('readonly', models.BooleanField(default=True, help_text='Campo de leitura apenas')),
                ('ruleset', django.contrib.postgres.fields.jsonb.JSONField(blank=True, help_text='Preencher com JSON', null=True)),
                ('choices', models.TextField(blank=True, help_text="Preencher 'valor: Descrição' | Delimitador das Opções: quebra de linha | Exemplo: 1: Cartesian", max_length=1000)),
                ('min_value', models.FloatField(blank=True, null=True)),
                ('max_value', models.FloatField(blank=True, null=True)),
                ('file_type', models.CharField(choices=[('param', 'param.in'), ('wwminput', 'wwminput.nml')], default='param', max_length=20)),
                ('parent', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelVersionParameter')),
            ],
            options={
                'verbose_name': 'Detail ModelVersion Parameter Waves',
                'verbose_name_plural': 'ModelVersion Parameters Waves',
            },
        ),
        migrations.CreateModel(
            name='SessionFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('file', models.BinaryField()),
                ('file_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.FileType')),
                ('session', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='sessions.Session')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Station',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.CharField(max_length=50)),
                ('source', models.CharField(max_length=200)),
                ('owner', models.CharField(max_length=100)),
                ('name', models.CharField(blank=True, max_length=100)),
                ('params', models.CharField(blank=True, help_text='Delimitador das Opções: ;', max_length=500)),
                ('notes', models.CharField(blank=True, max_length=100)),
                ('active', models.BooleanField(default=True)),
                ('point', django.contrib.gis.db.models.fields.PointField(blank=True, srid=4236)),
            ],
            options={
                'verbose_name': 'Detail Station',
                'verbose_name_plural': 'Stations',
            },
        ),
        migrations.CreateModel(
            name='UserProfile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('affiliation', models.CharField(max_length=100)),
                ('affiliation_country', django_countries.fields.CountryField(max_length=2)),
                ('confirm_registration', models.BooleanField(default=False, verbose_name='Registo confirmado')),
                ('read_disclaimer', models.BooleanField(default=False, verbose_name='Termos e condições aceites')),
                ('deploy_period', models.IntegerField(default=30, help_text='Em dias', verbose_name='Duração Sistema')),
                ('deploy_maxnr', models.IntegerField(default=5, verbose_name='Máximo Sistemas ativos')),
                ('station_maxnr', models.IntegerField(default=5, verbose_name='Máximo Estações')),
                ('node_maxnr', models.IntegerField(default=175000, verbose_name='Máximo Nós')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='UserProfileRating',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('creation_datetime', models.DateTimeField(default=datetime.datetime.now)),
                ('value', models.IntegerField()),
                ('text', models.TextField(blank=True, null=True)),
                ('userprofile', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='front.UserProfile')),
            ],
        ),
        migrations.AddField(
            model_name='bbox',
            name='forcing_source',
            field=models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='forcing', to='front.ForcingSource'),
        ),
    ]
